<script lang="ts">
  import '../../app.scss';
  import '../sandbox.scss';
  import NavBar from '@components/Sandbox/SandboxNavbar.svelte';
  import Notifications from 'svelte-notifications';
  import Env from '@env';
  import { Alert } from '@sveltestrap/sveltestrap';
  import { writable } from 'svelte/store';
  import oidc from '@auth/keycloak';
  import { Gql } from '@db';

  const authStatusStore = writable('not initialized');
  let displayHelp = false;

  async function initializeAuth() {
    setTimeout(() => (displayHelp = true), 5000);
    // Initialize Keycloak
    await oidc.initialize();
    // Initialize GraphQL Client, which subscribes to keycloak
    Gql.initialize();
  }
</script>

{#if Env.IntercomWarning}
  <div class="m-2">
    <Alert color="warning">{Env.IntercomWarning}</Alert>
  </div>
{/if}
{#if Env.IntercomError}
  <div class="m-2">
    <Alert color="danger">{Env.IntercomError}</Alert>
  </div>
{/if}
{#await initializeAuth()}
  <div class="d-flex h-100 align-items-center justify-content-center">
    <div>
      <h1>Loading...</h1>
      {#if displayHelp}
        <p>This is taking longer than expected. Please reach out to the sandbox administrator.</p>
        <pre>{JSON.stringify(Env, null, 2)}</pre>
      {/if}
    </div>
  </div>
{:then _}
  <NavBar />

  <div class="container-fluid">
    <Notifications>
      <slot />
    </Notifications>
  </div>
{:catch e}
  <div class="d-flex align-items-center min-vh-100 flex-wrap w-100">
    <div class="mx-auto">
      <p>Uh oh! We've had a major hiccup, and it looks like the site is down.</p>
      <p>
        Please report this to us in Discord or at
        <a href="mailto:support@c2games.org">support@c2games.org</a>
      </p>
      <p>PLEASE REPORT THIS ERROR CODE: {$authStatusStore}</p>
      {#if e?.stack}
        <p class="p-1">Please Include the following information:</p>
        <pre>
          {e.stack}
        </pre>
      {/if}
    </div>
  </div>
{/await}
